---
title: FileSystemDirectoryEntry.createReader()
slug: Web/API/FileSystemDirectoryEntry/createReader
tags:
  - API
  - File System API
  - File and Directory Entries API
  - FileSystemDirectoryEntry
  - Files
  - Method
  - Non-standard
  - Reference
  - createReader
---
<p>{{APIRef("File System API")}}{{SeeCompatTable}}</p>

<p>The {{domxref("FileSystemDirectoryEntry")}} interface's method <code><strong>createReader</strong></code><strong><code>()</code></strong> returns a {{domxref("FileSystemDirectoryReader")}} object which can be used to read the entries in the directory.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>directoryReader</em> = <em>FileSystemDirectoryEntry</em>.createReader();</pre>

<h3 class="syntaxbox" id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p>A {{domxref("FileSystemDirectoryReader")}} object which can be used to read the directory's entries.</p>

<h2 id="Example">Example</h2>

<p>This example creates a method called <code>readDirectory()</code>, which fetches all of the entries in the specified {{domxref("FileSystemDirectoryEntry")}} and returns them in an array.</p>

<pre class="brush: js">function readDirectory(directory) {
  let dirReader = directory.createReader();
  let entries = [];

  let getEntries = function() {
    dirReader.readEntries(function(results) {
      if (results.length) {
        entries = entries.concat(toArray(results));
        getEntries();
      }
    }, function(error) {
      /* handle error -- error is a FileError object */
    });
  };

  getEntries();
  return entries;
}</pre>

<p>This works by creating an internal function, <code>getEntries()</code>, which calls itself recursively to get all the entries in the directory, concatenating each batch to the array. Each iteration, {{domxref("FileSystemDirectoryReader.readEntries", "readEntries()")}} is called to get more entries. When it returns an empty array, the end of the directory has beenr reached, and the recursion ends. Once control is returned to <code>readDirectory()</code>, the array is returned to the caller.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('File System API', '#dom-filesystemdirectoryentry-createreader', 'createReader()') }}</td>
   <td>{{ Spec2('File System API') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileSystemDirectoryEntry.createReader")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API">File and Directory Entries API</a></li>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API/Introduction">Introduction to the File System API</a></li>
 <li>{{domxref("FileSystemDirectoryReader")}}</li>
 <li>{{domxref("FileSystemDirectoryEntry")}}</li>
 <li>{{domxref("FileSystemFileEntry")}}</li>
 <li>{{domxref("FileSystemEntry")}}</li>
</ul>
